#ifndef BOARD_H
#define BOARD_H

#include "devices.h"

extern void quit();
void buttonPressRelease(int x, int y, char state);
void initBoard();

struct Board {
	
	// taille de la fenêtre (X11)	
	int winWidth, winHeight;
	double scale;
	
	int width;
    int height;
    
	int displayOffX, displayOffY;
    int border;
	
	TFT_eSPI *layer0;
			
	BlueLed ledBuiltin;

	Board();
	void draw(int windowSizeChanged, int forceRedraw);
	void buildLayer0();
	void drawLayer0();
	void drawFastLayer0();
	void drawDisplay();
	void setOrientation(int o);	
	int getOrientation();
	void computeBoardPositionInWindow();
	void computeDisplayPositionInWindow();
	int getDisplayOffX();
	int getDisplayOffY();
	void drawButton(int i, uint16_t color); 
};

#endif
