#ifndef WIO_H
#define WIO_H

#include "TFT_eSPI.h"
#include "devices.h"
#include "board.h"

#ifdef __cplusplus
extern "C" {
#endif
void pinMode(pin_size_t pin, uint8_t mode);
void digitalWrite(pin_size_t pin, uint8_t value);
uint8_t digitalRead(pin_size_t pin);
#ifdef __cplusplus
}
#endif

void buttonPressRelease(int x, int y, char state);

#define LED_BUILTIN 13

/*
 * BUTTON
 */
#define BUTTON_1 (28ul)
#define BUTTON_2 (29ul)
#define BUTTON_3 (30ul)
#define WIO_KEY_A (28ul)
#define WIO_KEY_B (29ul)
#define WIO_KEY_C (30ul)

/*
 * SWITCH
 */
#define SWITCH_X (31ul)
#define SWITCH_Y (32ul)
#define SWITCH_Z (33ul)
#define SWITCH_B (34ul)
#define SWITCH_U (35ul)

#define WIO_5S_UP (31ul)
#define WIO_5S_LEFT (32ul)
#define WIO_5S_RIGHT (33ul)
#define WIO_5S_DOWN (34ul)
#define WIO_5S_PRESS (35ul)

// Reset (extra : not used by defaut)

#define WIO_RESET (252ul)

// Recompile (extra : not used by defaut)

#define WIO_COMPILE (253ul)


/*
 * BUZZER_CTR
 */
#define BUZZER_CTR (12ul)
#define WIO_BUZZER (12ul)


extern Board board;
extern int ctrl;
extern int lastPressState;

#endif
