/*
	Copyright (C) 2022 Guénal Davalan. All right reserved.
	
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#include "cpu.h"
#include "Arduino.h"

bool initTimeDone;

void Io::setMode(uint8_t m) {
	mode=m;
	if(mode==INPUT_PULLUP) setValue(!getValue());
}

void Io::setValue(uint8_t v) {
	if(value==v) return;
    lastValue=value;
    value=v;
}

uint8_t Io::getValue() {
	if(mode==INPUT_NONE) return 0;
	return value;
}


CPU::CPU() {}


	
