#ifndef CPU_H
#define CPU_H


#include "Arduino.h"
#include <stdint.h>
#include <cstddef>

#define INPUT_NONE 0x04
#define INPUT_REV 0x08

#define digitalPinToInterrupt(p) (p)

#define NB_IO 256

extern double speedup;
extern bool initTimeDone;

struct Io {
    uint8_t mode, lastValue;
	uint16_t value;
    void (*isr)(void);
	bool itFlag;

    Io():mode(INPUT_NONE), value(0), isr(NULL), itFlag(0) {}

    void setMode(uint8_t mode);
    void setValue(uint8_t v);
    uint8_t getValue();
};


struct CPU {
	Io ios[NB_IO];
	void (*itVector[NB_IO])(void);
	uint8_t itMask[NB_IO];
	uint8_t itMode[NB_IO]; // LOW CHANGE RISING FALLING HIGH
	CPU();
};

extern CPU cpu;

#endif
