#ifndef DEVICES_H
#define DEVICES_H

#include <stdint.h>
#include <cstddef>
#include "cpu.h"

#include "posix.h" 

struct RGBColor {
	uint8_t r, g, b;

	RGBColor(uint8_t r=0, uint8_t g=0, uint8_t b=0);
	
	void setColor(uint8_t _r, uint8_t _g, uint8_t _b);
};

struct Led {
	pin_size_t pin;
	RGBColor color;

	Led();
	void setColor(uint8_t _r, uint8_t _g, uint8_t _b);
};

struct RedLed : public Led {
	RedLed();
};

struct GreenLed : public Led {
    GreenLed();
};

struct BlueLed : public Led {
    BlueLed();
};

struct YellowLed : public Led {
    YellowLed();
};


#endif
