#ifndef LOG_H
#define LOG_H

#include <string>
#include <sstream>
#include <iomanip>

/// Convert integer value `val` to text in hexadecimal format.
/// The minimum width is padded with leading zeros; if not 
/// specified, this `width` is derived from the type of the 
/// argument. Function suitable from char to long long.
/// Pointers, floating point values, etc. are not supported; 
/// passing them will result in an (intentional!) compiler error.
/// Basics from: http://stackoverflow.com/a/5100745/2932052

extern bool glogFlag;
extern int glogIndent;
void alog(std::string s);
void alog(char *s);

void glogInc();
void glogDec();
template <typename T> std::string int_to_hex(T val, size_t width=2*sizeof(T));

#endif
