#ifndef POSIX_H
#define POSIX_H

#include <stdint.h>

#include "cpu.h"

#ifdef __cplusplus
extern "C"
{
#endif

	/* define by specific board */
/*
	void pinMode(pin_size_t pin, uint8_t mode);
	void digitalWrite(pin_size_t pin, uint8_t value);
	uint8_t digitalRead(pin_size_t pin);
*/
	void initTime();
/*
	uint32_t millis();
	uint32_t micros();
	void delayMicroseconds(uint32_t t);
	void delay(uint32_t t);
*/	
	// or internal use
	int64_t getMicros(struct timeval *t);
	int64_t getTime();
	void setMicros(struct timeval *t, int64_t micros);
	void addTime(struct timeval *result, struct timeval *t1, struct timeval *t2);
	void subTime(struct timeval *result, struct timeval *t1, struct timeval *t2);


	//void pinMode(pin_size_t pin, uint8_t mode);
	//void digitalWrite(pin_size_t, uint8_t);
	//uint8_t digitalRead(pin_size_t);

	uint16_t analogRead(pin_size_t);
	void analogWrite(pin_size_t, uint8_t);
	
		
	void attachInterrupt(pin_size_t pin, void (*f)(void), uint8_t mode);
	void detachInterrupt(pin_size_t pin);

	void yield();
	int getEnvInt(char *name, int defaultValue);
	double getEnvDouble(char *name, double defaultValue);
	
#ifdef __cplusplus
}
#endif

#endif

