
#ifndef POSIXSERIAL_H
#define POSIXSERIAL_H

#include <inttypes.h>
#include <unistd.h>
#include <stdio.h>
#include "Stream.h"

extern int usbConnect;
extern double speedup;

void initSerial();

class PosixSerial : public Stream
{
  public:
	PosixSerial() {}
    void begin(unsigned long baud) { begin(baud, 0); }
    void begin(unsigned long, uint8_t);
    void end();
    virtual int available(void);
    virtual int peek(void);
    virtual int read(void);
    virtual int availableForWrite(void);
    virtual void flush(void);
    virtual size_t write(uint8_t);
    inline size_t write(unsigned long n) { return write((uint8_t)n); }
    inline size_t write(long n) { return write((uint8_t)n); }
    inline size_t write(unsigned int n) { return write((uint8_t)n); }
    inline size_t write(int n) { return write((uint8_t)n); }
    using Print::write; // pull in write(str) and write(buf, size) from Print
    operator bool() { 
		fprintf(stderr, "Serial ? : %d\n", usbConnect);
		if(!usbConnect) usleep((100*1000)/speedup); 
		return usbConnect; 
	}
};

extern PosixSerial Serial;

#endif
