#ifndef __X11_H
#define __X11_H

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/extensions/Xdbe.h>

#include "TFT_eSPI.h"

#include "board.h"

class Board;

extern Board board;

extern int doubleBuffered;
extern XdbeBackBuffer doubleBuff;
extern int windowPresent;

extern Display *disp;
extern Window xwin;

extern float accel_X, accel_Y;

void whenKeyPress(KeySym key);
uint16_t buttonPin(int key);

void drawScalledPixel(TFT_eSPI *tft, int x, int y, uint16_t color);
void startX11Thread();
void clearTftBackBuffer(); // display(s) back buffer
void copyBuff();
void copyBuffXwin();

void button(uint16_t pin, uint8_t state);

#endif
