#include "TFT_eSPI.h"

TFT_eSPI tft;

void setup() {

	/*

	Sur le terminal WIO, pour les BOUTONS :

	1. le mode INPUT n'est pas fixé par défaut. Si ni INPUT, 
	   ni INPUT_PULLUP est fixé, l'état du bouton reste à 0.

	2. INPUT et INPUT_PULLUP provoque le même comportement : 
		1 si non appuyé, 0 si appuyé.

	C'est un comportement original !

*/



	// Pour constater que INPUT et INPUT_PULLUP ont le même comportement
	pinMode(WIO_KEY_A, INPUT_PULLUP);
	pinMode(WIO_KEY_B, INPUT);

	// Commenter la ligne suivante pour constater que le mode INPUT n'est
	// pas par défaut sur les boutons. Si ligne commentée, C reste à 0.
	pinMode(WIO_KEY_C, INPUT); 

	// Encore pour constater INPUT=INPUT_PULLUP
	pinMode(WIO_5S_UP, INPUT);
	pinMode(WIO_5S_DOWN, INPUT_PULLUP);
	pinMode(WIO_5S_LEFT, INPUT);
	pinMode(WIO_5S_RIGHT, INPUT_PULLUP);
	pinMode(WIO_5S_PRESS, INPUT);

	tft.begin();
	tft.setRotation(3);
	tft.setTextSize(4);
	tft.fillRect(0,0,320,240, TFT_BLACK);

	tft.drawString("A:", 10, 20);
	tft.drawString("B:", 10, 60);
	tft.drawString("C:", 10, 100);

	tft.drawString("UP:", 100, 20);
    tft.drawString("RIGHT:", 100, 60);
    tft.drawString("LEFT:", 100, 100);
    tft.drawString("DOWN:", 100, 140);
    tft.drawString("PRESS:", 100, 180);

}

void loop() {
	tft.drawNumber(digitalRead(WIO_KEY_A), 40,20);
	tft.drawNumber(digitalRead(WIO_KEY_B), 40, 60);
    tft.drawNumber(digitalRead(WIO_KEY_C), 40, 100);

	tft.drawNumber(digitalRead(WIO_5S_UP), 240,20);
    tft.drawNumber(digitalRead(WIO_5S_RIGHT), 240, 60);
    tft.drawNumber(digitalRead(WIO_5S_LEFT), 240, 100);
    tft.drawNumber(digitalRead(WIO_5S_DOWN), 240, 140);
    tft.drawNumber(digitalRead(WIO_5S_PRESS), 240, 180);

	delay(100);
}
